cmake_minimum_required(VERSION 3.22)

project(workshop LANGUAGES C)

if (NOT DEFINED PACKAGE_NAME)
    set(PACKAGE_NAME ${PROJECT_NAME})
endif()

if (NOT DEFINED PACKAGE_VERSION)
    set(PACKAGE_VERSION "latest")
endif()

if (NOT DEFINED PACKAGE_ARCH)
    set(PACKAGE_ARCH ${CMAKE_SYSTEM_PROCESSOR})
endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CPACK_GENERATOR "TGZ")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_PACKAGE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/out)
set(CPACK_ARCHIVE_COMPONENT_INSTALL ON)
set(CPACK_COMPONENTS_ALL ${PROJECTNAME})
set(CPACK_PACKAGE_VERSION ${BUILD_VERSION})
set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_ARCH})

add_executable(main src/main.c)

install(TARGETS main RUNTIME COMPONENT ${PROJECTNAME})

include (CPack)
